OGRE: Ogre::RibbonTrail Class Reference - OGRE Documentation

# Ogre::RibbonTrail Class Reference

Subclass of BillboardChain which automatically leaves a trail behind one or more Node instances. More...

`#include <OgreRibbonTrail.h>`

Inheritance diagram for Ogre::RibbonTrail:

[legend]

List of all members.

## Public Types
typedef std::vector< Node * > | NodeList
typedef ConstVectorIterator < NodeList > | NodeIterator
enum | TexCoordDirection { TCD_U, TCD_V }
| The direction in which texture coordinates from elements of the chain are used. More...
typedef std::vector< Element > | ElementList
typedef std::vector < ShadowRenderable * > | ShadowRenderableList
typedef VectorIterator < ShadowRenderableList > | ShadowRenderableListIterator
## Public Member Functions
| RibbonTrail (const String &name, size_t maxElements=20, size_t numberOfChains=1, bool useTextureCoords=true, bool useColours=true)
| Constructor (don't use directly, use factory).
virtual | ~RibbonTrail ()
| destructor
virtual void | addNode (Node *n)
| Add a node to be tracked.
virtual void | removeNode (Node *n)
| Remove tracking on a given node.
virtual NodeIterator | getNodeIterator (void) const
| Get an iterator over the nodes which are being tracked.
virtual size_t | getChainIndexForNode (const Node *n)
| Get the chain index for a given Node being tracked.
virtual void | setTrailLength (Real len)
| Set the length of the trail.
virtual Real | getTrailLength (void) const
| Get the length of the trail.
void | setMaxChainElements (size_t maxElements)
| Set the maximum number of chain elements per chain.
void | setNumberOfChains (size_t numChains)
| Set the number of chain segments (this class can render multiple chains at once using the same material).
void | clearChain (size_t chainIndex)
| Remove all elements of a given chain (but leave the chain intact).
virtual void | setInitialColour (size_t chainIndex, const ColourValue &col)
| Set the starting ribbon colour for a given segment.
virtual void | setInitialColour (size_t chainIndex, Real r, Real g, Real b, Real a=1.0)
| Set the starting ribbon colour.
virtual const ColourValue & | getInitialColour (size_t chainIndex) const
| Get the starting ribbon colour.
virtual void | setColourChange (size_t chainIndex, const ColourValue &valuePerSecond)
| Enables / disables fading the trail using colour.
virtual void | setInitialWidth (size_t chainIndex, Real width)
| Set the starting ribbon width in world units.
virtual Real | getInitialWidth (size_t chainIndex) const
| Get the starting ribbon width in world units.
virtual void | setWidthChange (size_t chainIndex, Real widthDeltaPerSecond)
| Set the change in ribbon width per second.
virtual Real | getWidthChange (size_t chainIndex) const
| Get the change in ribbon width per second.
virtual void | setColourChange (size_t chainIndex, Real r, Real g, Real b, Real a)
| Enables / disables fading the trail using colour.
virtual const ColourValue & | getColourChange (size_t chainIndex) const
| Get the per-second fading amount.
void | nodeUpdated (const Node *node)
void | nodeDestroyed (const Node *node)
virtual void | _timeUpdate (Real time)
| Perform any fading / width delta required; internal method.
const String & | getMovableType (void) const
| Overridden from MovableObject.
virtual size_t | getMaxChainElements (void) const
| Get the maximum number of chain elements per chain.
virtual size_t | getNumberOfChains (void) const
| Get the number of chain segments (this class can render multiple chains at once using the same material).
virtual void | setUseTextureCoords (bool use)
| Sets whether texture coordinate information should be included in the final buffers generated.
virtual bool | getUseTextureCoords (void) const
| Gets whether texture coordinate information should be included in the final buffers generated.
virtual void | setTextureCoordDirection (TexCoordDirection dir)
| Sets the direction in which texture coords specified on each element are deemed to run along the length of the chain.
virtual TexCoordDirection | getTextureCoordDirection (void)
| Gets the direction in which texture coords specified on each element are deemed to run.
virtual void | setOtherTextureCoordRange (Real start, Real end)
| Set the range of the texture coordinates generated across the width of the chain elements.
virtual const Real * | getOtherTextureCoordRange (void) const
| Get the range of the texture coordinates generated across the width of the chain elements.
virtual void | setUseVertexColours (bool use)
| Sets whether vertex colour information should be included in the final buffers generated.
virtual bool | getUseVertexColours (void) const
| Gets whether vertex colour information should be included in the final buffers generated.
virtual void | setDynamic (bool dyn)
| Sets whether or not the buffers created for this object are suitable for dynamic alteration.
virtual bool | getDynamic (void) const
| Gets whether or not the buffers created for this object are suitable for dynamic alteration.
virtual void | addChainElement (size_t chainIndex, const Element &billboardChainElement)
| Add an element to the 'head' of a chain.
virtual void | removeChainElement (size_t chainIndex)
| Remove an element from the 'tail' of a chain.
virtual void | updateChainElement (size_t chainIndex, size_t elementIndex, const Element &billboardChainElement)
| Update the details of an existing chain element.
virtual const Element & | getChainElement (size_t chainIndex, size_t elementIndex) const
| Get the detail of a chain element.
virtual size_t | getNumChainElements (size_t chainIndex) const
| Returns the number of chain elements.
virtual void | clearAllChains (void)
| Remove all elements from all chains (but leave the chains themselves intact).
virtual const String & | getMaterialName (void) const
| Get the material name in use.
virtual void | setMaterialName (const String &name)
| Set the material name to use for rendering.
void | _notifyCurrentCamera (Camera *cam)
| Internal method to notify the object of the camera to be used for the next rendering operation.
Real | getSquaredViewDepth (const Camera *cam) const
| Returns the camera-relative squared depth of this renderable.
Real | getBoundingRadius (void) const
| Retrieves the radius of the origin-centered bounding sphere for this object.
const AxisAlignedBox & | getBoundingBox (void) const
| Retrieves the local axis-aligned bounding box for this object.
const MaterialPtr & | getMaterial (void) const
| Retrieves a weak reference to the material this renderable object uses.
void | _updateRenderQueue (RenderQueue *)
| Internal method by which the movable object must add Renderable subclass instances to the rendering queue.
void | getRenderOperation (RenderOperation &)
| Gets the render operation required to send this object to the frame buffer.
void | getWorldTransforms (Matrix4 *) const
| Gets the world transform matrix / matrices for this renderable object.
const LightList & | getLights (void) const
| Gets a list of lights, ordered relative to how close they are to this renderable.
void | visitRenderables (Renderable::Visitor *visitor, bool debugRenderables=false)
  | Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any. Parameters:
  | visitor | Pointer to a class implementing the Renderable::Visitor interface which will be called back for each Renderable which will be queued. Bear in mind that the state of the Renderable instances may not be finalised depending on when you call this.
  | debugRenderables | If false, only regular renderables will be visited (those for normal display). If true, debug renderables will be included too.
virtual void | _notifyCreator (MovableObjectFactory *fact)
| Notify the object of it's creator (internal use only).
virtual MovableObjectFactory * | _getCreator (void) const
| Get the creator of this object, if any (internal use only).
virtual void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only).
virtual SceneManager * | _getManager (void) const
| Get the manager of this object, if any (internal use only).
virtual const String & | getName (void) const
| Returns the name of this object.
virtual Node * | getParentNode (void) const
| Returns the node to which this object is attached.
virtual SceneNode * | getParentSceneNode (void) const
| Returns the scene node to which this object is attached.
virtual void | _notifyAttached (Node *parent, bool isTagPoint=false)
| Internal method called to notify the object that it has been attached to a node.
virtual bool | isAttached (void) const
| Returns true if this object is attached to a SceneNode or TagPoint.
virtual void | detatchFromParent (void)
| Detaches an object from a parent SceneNode or TagPoint, if attached.
virtual bool | isInScene (void) const
| Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.
virtual void | _notifyMoved (void)
| Internal method called to notify the object that it has been moved.
virtual const AxisAlignedBox & | getWorldBoundingBox (bool derive=false) const
| Retrieves the axis-aligned bounding box for this object in world coordinates.
virtual const Sphere & | getWorldBoundingSphere (bool derive=false) const
| Retrieves the worldspace bounding sphere for this object.
virtual void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
virtual bool | getVisible (void) const
| Gets this object whether to be visible or not, if it has a renderable component.
virtual bool | isVisible (void) const
| Returns whether or not this object is supposed to be visible or not.
virtual void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
virtual Real | getRenderingDistance (void) const
| Gets the distance at which batches are no longer rendered.
virtual void | setUserObject (UserDefinedObject *obj)
| Call this to associate your own custom user object instance with this MovableObject.
virtual UserDefinedObject * | getUserObject (void)
| Retrieves a pointer to a custom application object associated with this movable by an earlier call to setUserObject.
virtual void | setUserAny (const Any &anything)
| Sets any kind of user value on this object.
virtual void | setUserAny (const Any &anything)
| Sets any kind of user value on this object.
virtual const Any & | getUserAny (void) const
| Retrieves the custom user value associated with this object.
virtual const Any & | getUserAny (void) const
| Retrieves the custom user value associated with this object.
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through.
virtual uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity, see setRenderQueueGroup for full details.
virtual const Matrix4 & | _getParentNodeFullTransform (void) const
| return the full transformation of the parent sceneNode or the attachingPoint node
virtual void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
virtual void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
virtual void | removeQueryFlags (unsigned long flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
virtual uint32 | getQueryFlags (void) const
| Returns the query flags relevant for this object.
virtual void | setVisibilityFlags (uint32 flags)
| Sets the visiblity flags for this object.
virtual void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
virtual void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
virtual uint32 | getVisibilityFlags (void) const
| Returns the visibility flags relevant for this object.
virtual void | setListener (Listener *listener)
| Sets a listener for this object.
virtual Listener * | getListener (void) const
| Gets the current listener for this object.
virtual const LightList & | queryLights (void) const
| Gets a list of lights, ordered relative to how close they are to this movable object.
virtual LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object.
EdgeData * | getEdgeList (void)
| Define a default implementation of method from ShadowCaster which implements no shadows.
bool | hasEdgeList (void)
| Define a default implementation of method from ShadowCaster which implements no shadows.
ShadowRenderableListIterator | getShadowVolumeRenderableIterator (ShadowTechnique shadowTechnique, const Light *light, HardwareIndexBufferSharedPtr *indexBuffer, bool extrudeVertices, Real extrusionDist, unsigned long flags=0)
| Define a default implementation of method from ShadowCaster which implements no shadows.
const AxisAlignedBox & | getLightCapBounds (void) const
| Overridden member from ShadowCaster.
const AxisAlignedBox & | getDarkCapBounds (const Light &light, Real dirLightExtrusionDist) const
| Overridden member from ShadowCaster.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
bool | getCastShadows (void) const
| Returns whether shadow casting is enabled for this object.
Real | getPointExtrusionDistance (const Light *l) const
| Get the distance to extrude for a point/spot light.
virtual uint32 | getTypeFlags (void) const
| Get the 'type flags' for this MovableObject.
virtual void | setDebugDisplayEnabled (bool enabled)
| Sets whether or not the debug display of this object is enabled.
virtual bool | isDebugDisplayEnabled (void) const
| Gets whether debug display of this object is enabled.
const StringVector & | getAnimableValueNames (void) const
| Gets a list of animable value names for this object.
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
virtual Technique * | getTechnique (void) const
| Retrieves a pointer to the Material Technique this renderable object uses.
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys)
| Called just prior to the Renderable being rendered.
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered.
virtual unsigned short | getNumWorldTransforms (void) const
| Returns the number of world transform matrices this renderable requires.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view.
virtual bool | getCastsShadows (void) const
| Method which reports whether this renderable would normally cast a shadow.
void | setCustomParameter (size_t index, const Vector4 &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
const Vector4 & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
virtual void | _updateCustomGpuParameter (const GpuProgramParameters::AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
virtual void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
virtual bool | getPolygonModeOverrideable (void) const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
virtual RenderSystemData * | getRenderSystemData () const
| Sets render system private data.
virtual void | setRenderSystemData (RenderSystemData *val) const
| gets render system private data
virtual void | nodeAttached (const Node *)
| Node has been attached to a parent.
virtual void | nodeDetached (const Node *)
| Node has been detached from a parent.
## Static Public Member Functions
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | extrudeVertices (const HardwareVertexBufferSharedPtr &vertexBuffer, size_t originalVertexCount, const Vector4 &lightPos, Real extrudeDist)
| Utility method for extruding vertices based on a light.
## Protected Types
typedef std::vector< size_t > | IndexVector
| Mapping of nodes to chain segments.
typedef std::map< const Node *, size_t > | NodeToChainSegmentMap
typedef std::vector< ColourValue > | ColourValueList
typedef std::vector< Real > | RealList
typedef std::vector< ChainSegment > | ChainSegmentList
typedef std::map< String, StringVector > | AnimableDictionaryMap
typedef std::map< size_t, Vector4 > | CustomParameterMap
## Protected Member Functions
virtual void | manageController (void)
| Manage updates to the time controller.
virtual void | updateTrail (size_t index, const Node *node)
| Node has changed position, update.
virtual void | resetTrail (size_t index, const Node *node)
| Reset the tracked chain to initial state.
virtual void | resetAllTrails (void)
| Reset all tracked chains to initial state.
virtual void | setupChainContainers (void)
| Setup the STL collections.
virtual void | setupVertexDeclaration (void)
| Setup vertex declaration.
virtual void | setupBuffers (void)
virtual void | updateVertexBuffer (Camera *cam)
| Update the contents of the vertex buffer.
virtual void | updateIndexBuffer (void)
| Update the contents of the index buffer.
virtual void | updateBoundingBox (void) const
Real | getExtrusionDistance (const Vector3 &objectPos, const Light *light) const
| Helper method for calculating extrusion distance.
virtual void | updateEdgeListLightFacing (EdgeData *edgeData, const Vector4 &lightPos)
| Tells the caster to perform the tasks necessary to update the edge data's light listing.
virtual void | generateShadowVolume (EdgeData *edgeData, const HardwareIndexBufferSharedPtr &indexBuffer, const Light *light, ShadowRenderableList &shadowRenderables, unsigned long flags)
| Generates the indexes required to render a shadow volume into the index buffer which is passed in, and updates shadow renderables to use it.
virtual void | extrudeBounds (AxisAlignedBox &box, const Vector4 &lightPos, Real extrudeDist) const
| Utility method for extruding a bounding box.
virtual const String & | getAnimableDictionaryName (void) const
| Get the name of the animable dictionary for this class.
void | createAnimableDictionary (void) const
| Internal method for creating a dictionary of animable value names for the class, if it does not already exist.
StringVector & | _getAnimableValueNames (void)
| Get an updateable reference to animable value list.
virtual void | initialiseAnimableDictionary (StringVector &) const
| Internal method for initialising dictionary; should be implemented by subclasses wanting to expose animable parameters.
## Protected Attributes
NodeList | mNodeList
| List of nodes being trailed.
IndexVector | mNodeToChainSegment
| Ordered like mNodeList, contains chain index.
IndexVector | mFreeChains
NodeToChainSegmentMap | mNodeToSegMap
Real | mTrailLength
| Total length of trail in world units.
Real | mElemLength
| length of each element
Real | mSquaredElemLength
| Squared length of each element.
ColourValueList | mInitialColour
| Initial colour of the ribbon.
ColourValueList | mDeltaColour
| fade amount per second
RealList | mInitialWidth
| Initial width of the ribbon.
RealList | mDeltaWidth
| Delta width of the ribbon.
Controller< Real > * | mFadeController
| controller used to hook up frame time to fader
ControllerValueRealPtr | mTimeControllerValue
| controller value for hooking up frame time to fader
size_t | mMaxElementsPerChain
| Maximum length of each chain.
size_t | mChainCount
| Number of chains.
bool | mUseTexCoords
| Use texture coords?
bool | mUseVertexColour
| Use vertex colour?
bool | mDynamic
| Dynamic use?
VertexData * | mVertexData
| Vertex data.
IndexData * | mIndexData
| Index data (to allow multiple unconnected chains).
bool | mVertexDeclDirty
| Is the vertex declaration dirty?
bool | mBuffersNeedRecreating
| Do the buffers need recreating?
bool | mBoundsDirty
| Do the bounds need redefining?
bool | mIndexContentDirty
| Is the index buffer dirty?
AxisAlignedBox | mAABB
| AABB.
Real | mRadius
| Bounding radius.
String | mMaterialName
| Material.
MaterialPtr | mMaterial
TexCoordDirection | mTexCoordDir
| Texture coord direction.
Real | mOtherTexCoordRange [2]
| Other texture coord range.
ElementList | mChainElementList
| The list holding the chain elements.
ChainSegmentList | mChainSegmentList
String | mName
| Name of this object.
MovableObjectFactory * | mCreator
| Creator of this object (if created by a factory).
SceneManager * | mManager
| SceneManager holding this object (if applicable).
Node * | mParentNode
| node to which this object is attached
bool | mParentIsTagPoint
bool | mVisible
| Is this object visible?
bool | mDebugDisplay
| Is debug display enabled?
Real | mUpperDistance
| Upper distance to still render.
Real | mSquaredUpperDistance
bool | mBeyondFarDistance
| Hidden because of distance?
Any | mUserAny
| User defined link to another object / value / whatever.
Any | mUserAny
uint8 | mRenderQueueID
| The render queue to use when rendering this object.
bool | mRenderQueueIDSet
| Flags whether the RenderQueue's default should be used.
uint32 | mQueryFlags
| Flags determining whether this object is included / excluded from scene queries.
uint32 | mVisibilityFlags
| Flags determining whether this object is visible (compared to SceneManager mask).
AxisAlignedBox | mWorldAABB
| Cached world AABB of this object.
Sphere | mWorldBoundingSphere
AxisAlignedBox | mWorldDarkCapBounds
| World space AABB of this object's dark cap.
bool | mCastShadows
| Does this object cast shadows?
bool | mRenderingDisabled
| Does rendering this object disabled by listener?
Listener * | mListener
| MovableObject listener - only one allowed (no list) for size & performance reasons. */.
LightList | mLightList
| List of lights for this object.
ulong | mLightListUpdated
| The last frame that this light list was updated in.
CustomParameterMap | mCustomParameters
bool | mPolygonModeOverrideable
bool | mUseIdentityProjection
bool | mUseIdentityView
RenderSystemData * | mRenderSystemData
## Static Protected Attributes
static const size_t | SEGMENT_EMPTY
| Chain segment has no elements.
static uint32 | msDefaultQueryFlags
| Default query flags.
static uint32 | msDefaultVisibilityFlags
| Default visibility flags.
static AnimableDictionaryMap | msAnimableDictionary
| Static map of class name to list of animable value names.

## Detailed Description

Subclass of BillboardChain which automatically leaves a trail behind one or more Node instances.

Remarks:
  An instance of this class will watch one or more Node instances, and automatically generate a trail behind them as they move. Because this class can monitor multiple modes, it generates its own geometry in world space and thus, even though it has to be attached to a SceneNode to be visible, changing the position of the scene node it is attached to makes no difference to the geometry rendered.

  The 'head' element grows smoothly in size until it reaches the required size, then a new element is added. If the segment is full, the tail element shrinks by the same proportion as the head grows before disappearing.

  Elements can be faded out on a time basis, either by altering their colour or altering their alpha. The width can also alter over time.

  'v' texture coordinates are fixed at 0.0 if used, meaning that you can use a 1D texture to 'smear' a colour pattern along the ribbon if you wish. The 'u' coordinates are by default (0.0, 1.0), but you can alter this using setOtherTexCoordRange if you wish.

Definition at line 65 of file OgreRibbonTrail.h.

## Member Typedef Documentation

typedef std::vector<Node*> Ogre::RibbonTrail::NodeList

Definition at line 82 of file OgreRibbonTrail.h.

typedef ConstVectorIterator<NodeList> Ogre::RibbonTrail::NodeIterator

Definition at line 83 of file OgreRibbonTrail.h.

typedef std::vector<size_t> Ogre::RibbonTrail::IndexVector`[protected]`

Mapping of nodes to chain segments.

Definition at line 176 of file OgreRibbonTrail.h.

typedef std::map<const Node*, size_t> Ogre::RibbonTrail::NodeToChainSegmentMap`[protected]`

Definition at line 184 of file OgreRibbonTrail.h.

typedef std::vector<ColourValue> Ogre::RibbonTrail::ColourValueList`[protected]`

Definition at line 193 of file OgreRibbonTrail.h.

typedef std::vector<Real> Ogre::RibbonTrail::RealList`[protected]`

Definition at line 194 of file OgreRibbonTrail.h.

typedef std::vector<Element> Ogre::BillboardChain::ElementList`[inherited]`

Definition at line 96 of file OgreBillboardChain.h.

typedef std::vector<ChainSegment> Ogre::BillboardChain::ChainSegmentList`[protected, inherited]`

Definition at line 307 of file OgreBillboardChain.h.

typedef std::vector<ShadowRenderable*> Ogre::ShadowCaster::ShadowRenderableList`[inherited]`

Definition at line 123 of file OgreShadowCaster.h.

typedef VectorIterator<ShadowRenderableList> Ogre::ShadowCaster::ShadowRenderableListIterator`[inherited]`

Definition at line 124 of file OgreShadowCaster.h.

typedef std::map<String, StringVector> Ogre::AnimableObject::AnimableDictionaryMap`[protected, inherited]`

Definition at line 234 of file OgreAnimable.h.

typedef std::map<size_t, Vector4> Ogre::Renderable::CustomParameterMap`[protected, inherited]`

Definition at line 371 of file OgreRenderable.h.

## Member Enumeration Documentation

enum Ogre::BillboardChain::TexCoordDirection`[inherited]`

The direction in which texture coordinates from elements of the chain are used.

Enumerator:

  TCD_U | Tex coord in elements is treated as the 'u' texture coordinate.
  TCD_V | Tex coord in elements is treated as the 'v' texture coordinate.

Definition at line 141 of file OgreBillboardChain.h.

## Constructor & Destructor Documentation

Ogre::RibbonTrail::RibbonTrail | ( | const String & | name,
|  | size_t | maxElements = `20`,
|  | size_t | numberOfChains = `1`,
|  | bool | useTextureCoords = `true`,
|  | bool | useColours = `true` |
| ) |  |  |

Constructor (don't use directly, use factory).

Parameters:

  | name | The name to give this object
  | maxElements | The maximum number of elements per chain
  | numberOfChains | The number of separate chain segments contained in this object, ie the maximum number of nodes that can have trails attached
  | useTextureCoords | If true, use texture coordinates from the chain elements
  | useVertexColours | If true, use vertex colours from the chain elements (must be true if you intend to use fading)

virtual Ogre::RibbonTrail::~RibbonTrail | ( |  | ) | `[virtual]`

destructor

## Member Function Documentation

virtual void Ogre::RibbonTrail::addNode | ( | Node * | n | ) | `[virtual]`

Add a node to be tracked.

Parameters:

  | n | The node that will be tracked.

virtual void Ogre::RibbonTrail::removeNode | ( | Node * | n | ) | `[virtual]`

Remove tracking on a given node.

virtual NodeIterator Ogre::RibbonTrail::getNodeIterator | ( | void |  | ) | const`[virtual]`

Get an iterator over the nodes which are being tracked.

virtual size_t Ogre::RibbonTrail::getChainIndexForNode | ( | const Node * | n | ) | `[virtual]`

Get the chain index for a given Node being tracked.

virtual void Ogre::RibbonTrail::setTrailLength | ( | Real | len | ) | `[virtual]`

Set the length of the trail.

Remarks:
  This sets the length of the trail, in world units. It also sets how far apart each segment will be, ie length / max_elements.

Parameters:

  | len | The length of the trail in world units

virtual Real Ogre::RibbonTrail::getTrailLength | ( | void |  | ) | const`[virtual]`

Get the length of the trail.

Definition at line 104 of file OgreRibbonTrail.h.

void Ogre::RibbonTrail::setMaxChainElements | ( | size_t | maxElements | ) | `[virtual]`

Set the maximum number of chain elements per chain.

Reimplemented from Ogre::BillboardChain.

void Ogre::RibbonTrail::setNumberOfChains | ( | size_t | numChains | ) | `[virtual]`

Set the number of chain segments (this class can render multiple chains at once using the same material).

Reimplemented from Ogre::BillboardChain.

void Ogre::RibbonTrail::clearChain | ( | size_t | chainIndex | ) | `[virtual]`

Remove all elements of a given chain (but leave the chain intact).

Reimplemented from Ogre::BillboardChain.

virtual void Ogre::RibbonTrail::setInitialColour | ( | size_t | chainIndex,
|  | const ColourValue & | col |
| ) |  |  | `[virtual]`

Set the starting ribbon colour for a given segment.

Parameters:

  | chainIndex | The index of the chain
  | col | The initial colour

Note:
  Only used if this instance is using vertex colours.

virtual void Ogre::RibbonTrail::setInitialColour | ( | size_t | chainIndex,
|  | Real | r,
|  | Real | g,
|  | Real | b,
|  | Real | a = `1.0` |
| ) |  |  | `[virtual]`

Set the starting ribbon colour.

Parameters:

  | chainIndex | The index of the chain
  | r,b,g,a | The initial colour

Note:
  Only used if this instance is using vertex colours.

virtual const ColourValue& Ogre::RibbonTrail::getInitialColour | ( | size_t | chainIndex | ) | const`[virtual]`

Get the starting ribbon colour.

virtual void Ogre::RibbonTrail::setColourChange | ( | size_t | chainIndex,
|  | const ColourValue & | valuePerSecond |
| ) |  |  | `[virtual]`

Enables / disables fading the trail using colour.

Parameters:

  | chainIndex | The index of the chain
  | valuePerSecond | The amount to subtract from colour each second

virtual void Ogre::RibbonTrail::setInitialWidth | ( | size_t | chainIndex,
|  | Real | width |
| ) |  |  | `[virtual]`

Set the starting ribbon width in world units.

Parameters:

  | chainIndex | The index of the chain
  | width | The initial width of the ribbon

virtual Real Ogre::RibbonTrail::getInitialWidth | ( | size_t | chainIndex | ) | const`[virtual]`

Get the starting ribbon width in world units.

virtual void Ogre::RibbonTrail::setWidthChange | ( | size_t | chainIndex,
|  | Real | widthDeltaPerSecond |
| ) |  |  | `[virtual]`

Set the change in ribbon width per second.

Parameters:

  | chainIndex | The index of the chain
  | widthDeltaPerSecond | The amount the width will reduce by per second

virtual Real Ogre::RibbonTrail::getWidthChange | ( | size_t | chainIndex | ) | const`[virtual]`

Get the change in ribbon width per second.

virtual void Ogre::RibbonTrail::setColourChange | ( | size_t | chainIndex,
|  | Real | r,
|  | Real | g,
|  | Real | b,
|  | Real | a |
| ) |  |  | `[virtual]`

Enables / disables fading the trail using colour.

Parameters:

  | chainIndex | The index of the chain
  | r,g,b,a | The amount to subtract from each colour channel per second

virtual const ColourValue& Ogre::RibbonTrail::getColourChange | ( | size_t | chainIndex | ) | const`[virtual]`

Get the per-second fading amount.

void Ogre::RibbonTrail::nodeUpdated | ( | const Node * | node | ) | `[virtual]`

See also:
  Node::Listener::nodeUpdated

Reimplemented from Ogre::Node::Listener.

void Ogre::RibbonTrail::nodeDestroyed | ( | const Node * | node | ) | `[virtual]`

See also:
  Node::Listener::nodeDestroyed

Reimplemented from Ogre::Node::Listener.

virtual void Ogre::RibbonTrail::_timeUpdate | ( | Real | time | ) | `[virtual]`

Perform any fading / width delta required; internal method.

const String& Ogre::RibbonTrail::getMovableType | ( | void |  | ) | const`[virtual]`

Overridden from MovableObject.

Reimplemented from Ogre::BillboardChain.

virtual void Ogre::RibbonTrail::manageController | ( | void |  | ) | `[protected, virtual]`

Manage updates to the time controller.

virtual void Ogre::RibbonTrail::updateTrail | ( | size_t | index,
|  | const Node * | node |
| ) |  |  | `[protected, virtual]`

Node has changed position, update.

virtual void Ogre::RibbonTrail::resetTrail | ( | size_t | index,
|  | const Node * | node |
| ) |  |  | `[protected, virtual]`

Reset the tracked chain to initial state.

virtual void Ogre::RibbonTrail::resetAllTrails | ( | void |  | ) | `[protected, virtual]`

Reset all tracked chains to initial state.

virtual size_t Ogre::BillboardChain::getMaxChainElements | ( | void |  | ) | const`[virtual, inherited]`

Get the maximum number of chain elements per chain.

Definition at line 116 of file OgreBillboardChain.h.

virtual size_t Ogre::BillboardChain::getNumberOfChains | ( | void |  | ) | const`[virtual, inherited]`

Get the number of chain segments (this class can render multiple chains at once using the same material).

Definition at line 124 of file OgreBillboardChain.h.

virtual void Ogre::BillboardChain::setUseTextureCoords | ( | bool | use | ) | `[virtual, inherited]`

Sets whether texture coordinate information should be included in the final buffers generated.

Note:
  You must use either texture coordinates or vertex colour since the vertices have no normals and without one of these there is no source of colour for the vertices.

virtual bool Ogre::BillboardChain::getUseTextureCoords | ( | void |  | ) | const`[virtual, inherited]`

Gets whether texture coordinate information should be included in the final buffers generated.

Definition at line 136 of file OgreBillboardChain.h.

virtual void Ogre::BillboardChain::setTextureCoordDirection | ( | TexCoordDirection | dir | ) | `[virtual, inherited]`

Sets the direction in which texture coords specified on each element are deemed to run along the length of the chain.

Parameters:

  | dir | The direction, default is TCD_U.

virtual TexCoordDirection Ogre::BillboardChain::getTextureCoordDirection | ( | void |  | ) | `[virtual, inherited]`

Gets the direction in which texture coords specified on each element are deemed to run.

Definition at line 156 of file OgreBillboardChain.h.

virtual void Ogre::BillboardChain::setOtherTextureCoordRange | ( | Real | start,
|  | Real | end |
| ) |  |  | `[virtual, inherited]`

Set the range of the texture coordinates generated across the width of the chain elements.

Parameters:

  | start | Start coordinate, default 0.0
  | end | End coordinate, default 1.0

virtual const Real* Ogre::BillboardChain::getOtherTextureCoordRange | ( | void |  | ) | const`[virtual, inherited]`

Get the range of the texture coordinates generated across the width of the chain elements.

Definition at line 167 of file OgreBillboardChain.h.

virtual void Ogre::BillboardChain::setUseVertexColours | ( | bool | use | ) | `[virtual, inherited]`

Sets whether vertex colour information should be included in the final buffers generated.

Note:
  You must use either texture coordinates or vertex colour since the vertices have no normals and without one of these there is no source of colour for the vertices.

virtual bool Ogre::BillboardChain::getUseVertexColours | ( | void |  | ) | const`[virtual, inherited]`

Gets whether vertex colour information should be included in the final buffers generated.

Definition at line 179 of file OgreBillboardChain.h.

virtual void Ogre::BillboardChain::setDynamic | ( | bool | dyn | ) | `[virtual, inherited]`

Sets whether or not the buffers created for this object are suitable for dynamic alteration.

virtual bool Ogre::BillboardChain::getDynamic | ( | void |  | ) | const`[virtual, inherited]`

Gets whether or not the buffers created for this object are suitable for dynamic alteration.

Definition at line 189 of file OgreBillboardChain.h.

virtual void Ogre::BillboardChain::addChainElement | ( | size_t | chainIndex,
|  | const Element & | billboardChainElement |
| ) |  |  | `[virtual, inherited]`

Add an element to the 'head' of a chain.

Remarks:
  If this causes the number of elements to exceed the maximum elements per chain, the last element in the chain (the 'tail') will be removed to allow the additional element to be added.

Parameters:

  | chainIndex | The index of the chain
  | billboardChainElement | The details to add

virtual void Ogre::BillboardChain::removeChainElement | ( | size_t | chainIndex | ) | `[virtual, inherited]`

Remove an element from the 'tail' of a chain.

Parameters:

  | chainIndex | The index of the chain

virtual void Ogre::BillboardChain::updateChainElement | ( | size_t | chainIndex,
|  | size_t | elementIndex,
|  | const Element & | billboardChainElement |
| ) |  |  | `[virtual, inherited]`

Update the details of an existing chain element.

Parameters:

  | chainIndex | The index of the chain
  | elementIndex | The element index within the chain, measured from the 'head' of the chain
  | billboardChainElement | The details to set

virtual const Element& Ogre::BillboardChain::getChainElement | ( | size_t | chainIndex,
|  | size_t | elementIndex |
| ) |  |  | const`[virtual, inherited]`

Get the detail of a chain element.

Parameters:

  | chainIndex | The index of the chain
  | elementIndex | The element index within the chain, measured from the 'head' of the chain

virtual size_t Ogre::BillboardChain::getNumChainElements | ( | size_t | chainIndex | ) | const`[virtual, inherited]`

Returns the number of chain elements.

virtual void Ogre::BillboardChain::clearAllChains | ( | void |  | ) | `[virtual, inherited]`

Remove all elements from all chains (but leave the chains themselves intact).

virtual const String& Ogre::BillboardChain::getMaterialName | ( | void |  | ) | const`[virtual, inherited]`

Get the material name in use.

Definition at line 229 of file OgreBillboardChain.h.

virtual void Ogre::BillboardChain::setMaterialName | ( | const String & | name | ) | `[virtual, inherited]`

Set the material name to use for rendering.

void Ogre::BillboardChain::_notifyCurrentCamera | ( | Camera * | cam | ) | `[virtual, inherited]`

Internal method to notify the object of the camera to be used for the next rendering operation.

Remarks:
  Certain objects may want to do specific processing based on the camera position. This method notifies them in case they wish to do this.

Reimplemented from Ogre::MovableObject.

Real Ogre::BillboardChain::getSquaredViewDepth | ( | const Camera * | cam | ) | const`[virtual, inherited]`

Returns the camera-relative squared depth of this renderable.

Remarks:
  Used to sort transparent objects. Squared depth is used rather than actual depth to avoid having to perform a square root on the result.

Implements Ogre::Renderable.

Real Ogre::BillboardChain::getBoundingRadius | ( | void |  | ) | const`[virtual, inherited]`

Retrieves the radius of the origin-centered bounding sphere for this object.

Implements Ogre::MovableObject.

const AxisAlignedBox& Ogre::BillboardChain::getBoundingBox | ( | void |  | ) | const`[virtual, inherited]`

Retrieves the local axis-aligned bounding box for this object.

Remarks:
  This bounding box is in local coordinates.

Implements Ogre::MovableObject.

const MaterialPtr& Ogre::BillboardChain::getMaterial | ( | void |  | ) | const`[virtual, inherited]`

Retrieves a weak reference to the material this renderable object uses.

Remarks:
  Note that the Renderable also has the option to override the getTechnique method to specify a particular Technique to use instead of the best one available.

Implements Ogre::Renderable.

void Ogre::BillboardChain::_updateRenderQueue | ( | RenderQueue * | queue | ) | `[virtual, inherited]`

Internal method by which the movable object must add Renderable subclass instances to the rendering queue.

Remarks:
  The engine will call this method when this object is to be rendered. The object must then create one or more Renderable subclass instances which it places on the passed in Queue for rendering.

Implements Ogre::MovableObject.

void Ogre::BillboardChain::getRenderOperation | ( | RenderOperation & | op | ) | `[virtual, inherited]`

Gets the render operation required to send this object to the frame buffer.

Implements Ogre::Renderable.

void Ogre::BillboardChain::getWorldTransforms | ( | Matrix4 * | xform | ) | const`[virtual, inherited]`

Gets the world transform matrix / matrices for this renderable object.

Remarks:
  If the object has any derived transforms, these are expected to be up to date as long as all the SceneNode structures have been updated before this is called.

  This method will populate xform with 1 matrix if it does not use vertex blending. If it does use vertex blending it will fill the passed in pointer with an array of matrices, the length being the value returned from getNumWorldTransforms.

Note:
  Internal Ogre never supports non-affine matrix for world transform matrix/matrices, the behavior is undefined if returns non-affine matrix here.

See also:
  Matrix4::isAffine.

Implements Ogre::Renderable.

const LightList& Ogre::BillboardChain::getLights | ( | void |  | ) | const`[virtual, inherited]`

Gets a list of lights, ordered relative to how close they are to this renderable.

Remarks:
  Directional lights, which have no position, will always be first on this list.

Implements Ogre::Renderable.

void Ogre::BillboardChain::visitRenderables | ( | Renderable::Visitor * | visitor,
|  | bool | debugRenderables = `false` |
| ) |  |  | `[virtual, inherited]`

Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.

Parameters:

  | visitor | Pointer to a class implementing the Renderable::Visitor interface which will be called back for each Renderable which will be queued. Bear in mind that the state of the Renderable instances may not be finalised depending on when you call this.
  | debugRenderables | If false, only regular renderables will be visited (those for normal display). If true, debug renderables will be included too.

Implements Ogre::MovableObject.

virtual void Ogre::BillboardChain::setupChainContainers | ( | void |  | ) | `[protected, virtual, inherited]`

Setup the STL collections.

virtual void Ogre::BillboardChain::setupVertexDeclaration | ( | void |  | ) | `[protected, virtual, inherited]`

Setup vertex declaration.

virtual void Ogre::BillboardChain::setupBuffers | ( | void |  | ) | `[protected, virtual, inherited]`

virtual void Ogre::BillboardChain::updateVertexBuffer | ( | Camera * | cam | ) | `[protected, virtual, inherited]`

Update the contents of the vertex buffer.

virtual void Ogre::BillboardChain::updateIndexBuffer | ( | void |  | ) | `[protected, virtual, inherited]`

Update the contents of the index buffer.

virtual void Ogre::BillboardChain::updateBoundingBox | ( | void |  | ) | const`[protected, virtual, inherited]`

virtual void Ogre::MovableObject::_notifyCreator | ( | MovableObjectFactory * | fact | ) | `[virtual, inherited]`

Notify the object of it's creator (internal use only).

Definition at line 169 of file OgreMovableObject.h.

virtual MovableObjectFactory* Ogre::MovableObject::_getCreator | ( | void |  | ) | const`[virtual, inherited]`

Get the creator of this object, if any (internal use only).

Definition at line 171 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::_notifyManager | ( | SceneManager * | man | ) | `[virtual, inherited]`

Notify the object of it's manager (internal use only).

Definition at line 173 of file OgreMovableObject.h.

virtual SceneManager* Ogre::MovableObject::_getManager | ( | void |  | ) | const`[virtual, inherited]`

Get the manager of this object, if any (internal use only).

Definition at line 175 of file OgreMovableObject.h.

virtual const String& Ogre::MovableObject::getName | ( | void |  | ) | const`[virtual, inherited]`

Returns the name of this object.

Reimplemented in Ogre::Camera.

Definition at line 178 of file OgreMovableObject.h.

virtual Node* Ogre::MovableObject::getParentNode | ( | void |  | ) | const`[virtual, inherited]`

Returns the node to which this object is attached.

Remarks:
  A MovableObject may be attached to either a SceneNode or to a TagPoint, the latter case if it's attached to a bone on an animated entity. Both are Node subclasses so this method will return either.

virtual SceneNode* Ogre::MovableObject::getParentSceneNode | ( | void |  | ) | const`[virtual, inherited]`

Returns the scene node to which this object is attached.

Remarks:
  A MovableObject may be attached to either a SceneNode or to a TagPoint, the latter case if it's attached to a bone on an animated entity. This method will return the scene node of the parent entity if the latter is true.

virtual void Ogre::MovableObject::_notifyAttached | ( | Node * | parent,
|  | bool | isTagPoint = `false` |
| ) |  |  | `[virtual, inherited]`

Internal method called to notify the object that it has been attached to a node.

Reimplemented in Ogre::Entity, Ogre::Light, and Ogre::ParticleSystem.

virtual bool Ogre::MovableObject::isAttached | ( | void |  | ) | const`[virtual, inherited]`

Returns true if this object is attached to a SceneNode or TagPoint.

virtual void Ogre::MovableObject::detatchFromParent | ( | void |  | ) | `[virtual, inherited]`

Detaches an object from a parent SceneNode or TagPoint, if attached.

virtual bool Ogre::MovableObject::isInScene | ( | void |  | ) | const`[virtual, inherited]`

Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.

virtual void Ogre::MovableObject::_notifyMoved | ( | void |  | ) | `[virtual, inherited]`

Internal method called to notify the object that it has been moved.

Reimplemented in Ogre::Light.

virtual const AxisAlignedBox& Ogre::MovableObject::getWorldBoundingBox | ( | bool | derive = `false` | ) | const`[virtual, inherited]`

Retrieves the axis-aligned bounding box for this object in world coordinates.

Implements Ogre::ShadowCaster.

Reimplemented in Ogre::Entity.

virtual const Sphere& Ogre::MovableObject::getWorldBoundingSphere | ( | bool | derive = `false` | ) | const`[virtual, inherited]`

Retrieves the worldspace bounding sphere for this object.

Reimplemented in Ogre::Entity.

virtual void Ogre::MovableObject::setVisible | ( | bool | visible | ) | `[virtual, inherited]`

Tells this object whether to be visible or not, if it has a renderable component.

Note:
  An alternative approach of making an object invisible is to detach it from it's SceneNode, or to remove the SceneNode entirely. Detaching a node means that structurally the scene graph changes. Once this change has taken place, the objects / nodes that have been removed have less overhead to the visibility detection pass than simply making the object invisible, so if you do this and leave the objects out of the tree for a long time, it's faster. However, the act of detaching / reattaching nodes is in itself more expensive than setting an object visibility flag, since in the latter case structural changes are not made. Therefore, small or frequent visibility changes are best done using this method; large or more longer term changes are best done by detaching.

Reimplemented in Ogre::Light.

virtual bool Ogre::MovableObject::getVisible | ( | void |  | ) | const`[virtual, inherited]`

Gets this object whether to be visible or not, if it has a renderable component.

Remarks:
  Returns the value set by MovableObject::setVisible only.

virtual bool Ogre::MovableObject::isVisible | ( | void |  | ) | const`[virtual, inherited]`

Returns whether or not this object is supposed to be visible or not.

Remarks:
  Takes into account both upper rendering distance and visible flag.

Reimplemented in Ogre::InstancedGeometry::BatchInstance, and Ogre::StaticGeometry::Region.

virtual void Ogre::MovableObject::setRenderingDistance | ( | Real | dist | ) | `[virtual, inherited]`

Sets the distance at which the object is no longer rendered.

Parameters:

  | dist | Distance beyond which the object will not be rendered (the default is 0, which means objects are always rendered).

Definition at line 280 of file OgreMovableObject.h.

virtual Real Ogre::MovableObject::getRenderingDistance | ( | void |  | ) | const`[virtual, inherited]`

Gets the distance at which batches are no longer rendered.

Definition at line 286 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setUserObject | ( | UserDefinedObject * | obj | ) | `[virtual, inherited]`

Call this to associate your own custom user object instance with this MovableObject.

Remarks:
  By simply making your game / application object a subclass of UserDefinedObject, you can establish a link between an OGRE instance of MovableObject and your own application classes. Call this method to establish the link.

Definition at line 294 of file OgreMovableObject.h.

virtual UserDefinedObject* Ogre::MovableObject::getUserObject | ( | void |  | ) | `[virtual, inherited]`

Retrieves a pointer to a custom application object associated with this movable by an earlier call to setUserObject.

Definition at line 298 of file OgreMovableObject.h.

References Ogre::any_cast().

virtual void Ogre::MovableObject::setUserAny | ( | const Any & | anything | ) | `[virtual, inherited]`

Sets any kind of user value on this object.

Remarks:
  This method allows you to associate any user value you like with this MovableObject. This can be a pointer back to one of your own classes for instance.

Note:
  This value is shared with setUserObject so don't use both!

Definition at line 310 of file OgreMovableObject.h.

virtual void Ogre::Renderable::setUserAny | ( | const Any & | anything | ) | `[virtual, inherited]`

Sets any kind of user value on this object.

Remarks:
  This method allows you to associate any user value you like with this Renderable. This can be a pointer back to one of your own classes for instance.

Definition at line 315 of file OgreRenderable.h.

virtual const Any& Ogre::MovableObject::getUserAny | ( | void |  | ) | const`[virtual, inherited]`

Retrieves the custom user value associated with this object.

Definition at line 314 of file OgreMovableObject.h.

virtual const Any& Ogre::Renderable::getUserAny | ( | void |  | ) | const`[virtual, inherited]`

Retrieves the custom user value associated with this object.

Definition at line 319 of file OgreRenderable.h.

virtual void Ogre::MovableObject::setRenderQueueGroup | ( | uint8 | queueID | ) | `[virtual, inherited]`

Sets the render queue group this entity will be rendered through.

Remarks:
  Render queues are grouped to allow you to more tightly control the ordering of rendered objects. If you do not call this method, all Entity objects default to the default queue (RenderQueue::getDefaultQueueGroup), which is fine for most objects. You may want to alter this if you want this entity to always appear in front of other objects, e.g. for a 3D menu system or such.

  See RenderQueue for more details.

Parameters:

  | queueID | Enumerated value of the queue group to use.

Reimplemented in Ogre::Entity, and Ogre::ParticleSystem.

virtual uint8 Ogre::MovableObject::getRenderQueueGroup | ( | void |  | ) | const`[virtual, inherited]`

Gets the queue group for this entity, see setRenderQueueGroup for full details.

virtual const Matrix4& Ogre::MovableObject::_getParentNodeFullTransform | ( | void |  | ) | const`[virtual, inherited]`

return the full transformation of the parent sceneNode or the attachingPoint node

virtual void Ogre::MovableObject::setQueryFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

Sets the query flags for this object.

Remarks:
  When performing a scene query, this object will be included or excluded according to flags on the object and flags on the query. This is a bitwise value, so only when a bit on these flags is set, will it be included in a query asking for that flag. The meaning of the bits is application-specific.

Definition at line 342 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::addQueryFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.

Definition at line 346 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::removeQueryFlags | ( | unsigned long | flags | ) | `[virtual, inherited]`

As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.

Definition at line 350 of file OgreMovableObject.h.

virtual uint32 Ogre::MovableObject::getQueryFlags | ( | void |  | ) | const`[virtual, inherited]`

Returns the query flags relevant for this object.

Definition at line 353 of file OgreMovableObject.h.

static void Ogre::MovableObject::setDefaultQueryFlags | ( | uint32 | flags | ) | `[static, inherited]`

Set the default query flags for all future MovableObject instances.

Definition at line 357 of file OgreMovableObject.h.

static uint32 Ogre::MovableObject::getDefaultQueryFlags | ( |  | ) | `[static, inherited]`

Get the default query flags for all future MovableObject instances.

Definition at line 361 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

Sets the visiblity flags for this object.

Remarks:
  As well as a simple true/false value for visibility (as seen in setVisible), you can also set visiblity flags which when 'and'ed with the SceneManager's visibility mask can also make an object invisible.

Definition at line 370 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::addVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.

Definition at line 374 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::removeVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.

Definition at line 378 of file OgreMovableObject.h.

virtual uint32 Ogre::MovableObject::getVisibilityFlags | ( | void |  | ) | const`[virtual, inherited]`

Returns the visibility flags relevant for this object.

Definition at line 381 of file OgreMovableObject.h.

static void Ogre::MovableObject::setDefaultVisibilityFlags | ( | uint32 | flags | ) | `[static, inherited]`

Set the default visibility flags for all future MovableObject instances.

Definition at line 385 of file OgreMovableObject.h.

static uint32 Ogre::MovableObject::getDefaultVisibilityFlags | ( |  | ) | `[static, inherited]`

Get the default visibility flags for all future MovableObject instances.

Definition at line 389 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setListener | ( | Listener * | listener | ) | `[virtual, inherited]`

Sets a listener for this object.

Remarks:
  Note for size and performance reasons only one listener per object is allowed.

Definition at line 396 of file OgreMovableObject.h.

virtual Listener* Ogre::MovableObject::getListener | ( | void |  | ) | const`[virtual, inherited]`

Gets the current listener for this object.

Definition at line 400 of file OgreMovableObject.h.

virtual const LightList& Ogre::MovableObject::queryLights | ( | void |  | ) | const`[virtual, inherited]`

Gets a list of lights, ordered relative to how close they are to this movable object.

Remarks:
  By default, this method gives the listener a chance to populate light list first, if there is no listener or Listener::objectQueryLights returns NULL, it'll query the light list from parent entity if it is present, or returns SceneNode::findLights if it has parent scene node, otherwise it just returns an empty list.

  The object internally caches the light list, so it will recalculate it only when object is moved, or lights that affect the frustum have been changed (

See also:
  SceneManager::_getLightsDirtyCounter), but if listener exists, it will be called each time, so the listener should implement their own cache mechanism to optimise performance.

  This method can be useful when implementing Renderable::getLights in case the renderable is a part of the movable.

Returns:
  The list of lights use to lighting this object.

virtual LightList* Ogre::MovableObject::_getLightList | ( |  | ) | `[virtual, inherited]`

Returns a pointer to the current list of lights for this object.

Remarks:
  You should not modify this list outside of MovableObject::Listener::objectQueryLights (say if you want to use it to implement this method, and use the pointer as a return value) and for reading it's only accurate as at the last frame.

Definition at line 428 of file OgreMovableObject.h.

EdgeData* Ogre::MovableObject::getEdgeList | ( | void |  | ) | `[virtual, inherited]`

Define a default implementation of method from ShadowCaster which implements no shadows.

Implements Ogre::ShadowCaster.

Reimplemented in Ogre::Entity, Ogre::ManualObject, and Ogre::StaticGeometry::Region.

Definition at line 431 of file OgreMovableObject.h.

bool Ogre::MovableObject::hasEdgeList | ( | void |  | ) | `[virtual, inherited]`

Define a default implementation of method from ShadowCaster which implements no shadows.

Implements Ogre::ShadowCaster.

Reimplemented in Ogre::Entity, Ogre::ManualObject, and Ogre::StaticGeometry::Region.

Definition at line 433 of file OgreMovableObject.h.

ShadowRenderableListIterator Ogre::MovableObject::getShadowVolumeRenderableIterator | ( | ShadowTechnique | shadowTechnique,
|  | const Light * | light,
|  | HardwareIndexBufferSharedPtr * | indexBuffer,
|  | bool | extrudeVertices,
|  | Real | extrusionDist,
|  | unsigned long | flags = `0` |
| ) |  |  | `[virtual, inherited]`

Define a default implementation of method from ShadowCaster which implements no shadows.

Implements Ogre::ShadowCaster.

Reimplemented in Ogre::Entity, Ogre::ManualObject, and Ogre::StaticGeometry::Region.

const AxisAlignedBox& Ogre::MovableObject::getLightCapBounds | ( | void |  | ) | const`[virtual, inherited]`

Overridden member from ShadowCaster.

Implements Ogre::ShadowCaster.

const AxisAlignedBox& Ogre::MovableObject::getDarkCapBounds | ( | const Light & | light,
|  | Real | dirLightExtrusionDist |
| ) |  |  | const`[virtual, inherited]`

Overridden member from ShadowCaster.

Implements Ogre::ShadowCaster.

void Ogre::MovableObject::setCastShadows | ( | bool | enabled | ) | `[inherited]`

Sets whether or not this object will cast shadows.

Remarks:
  This setting simply allows you to turn on/off shadows for a given object. An object will not cast shadows unless the scene supports it in any case (see SceneManager::setShadowTechnique), and also the material which is in use must also have shadow casting enabled. By default all entities cast shadows. If, however, for some reason you wish to disable this for a single object then you can do so using this method.

Note:
  This method normally refers to objects which block the light, but since Light is also a subclass of MovableObject, in that context it means whether the light causes shadows itself.

Definition at line 456 of file OgreMovableObject.h.

bool Ogre::MovableObject::getCastShadows | ( | void |  | ) | const`[virtual, inherited]`

Returns whether shadow casting is enabled for this object.

Implements Ogre::ShadowCaster.

Definition at line 458 of file OgreMovableObject.h.

Real Ogre::MovableObject::getPointExtrusionDistance | ( | const Light * | l | ) | const`[virtual, inherited]`

Get the distance to extrude for a point/spot light.

Implements Ogre::ShadowCaster.

virtual uint32 Ogre::MovableObject::getTypeFlags | ( | void |  | ) | const`[virtual, inherited]`

Get the 'type flags' for this MovableObject.

Remarks:
  A type flag identifies the type of the MovableObject as a bitpattern. This is used for categorical inclusion / exclusion in SceneQuery objects. By default, this method returns all ones for objects not created by a MovableObjectFactory (hence always including them); otherwise it returns the value assigned to the MovableObjectFactory. Custom objects which don't use MovableObjectFactory will need to override this if they want to be included in queries.

Reimplemented in Ogre::BillboardSet, Ogre::Entity, Ogre::Frustum, Ogre::Light, Ogre::ParticleSystem, and Ogre::StaticGeometry::Region.

virtual void Ogre::MovableObject::setDebugDisplayEnabled | ( | bool | enabled | ) | `[virtual, inherited]`

Sets whether or not the debug display of this object is enabled.

Remarks:
  Some objects aren't visible themselves but it can be useful to display a debug representation of them. Or, objects may have an additional debug display on top of their regular display. This option enables / disables that debug display. Objects that are not visible never display debug geometry regardless of this setting.

Definition at line 495 of file OgreMovableObject.h.

virtual bool Ogre::MovableObject::isDebugDisplayEnabled | ( | void |  | ) | const`[virtual, inherited]`

Gets whether debug display of this object is enabled.

Definition at line 497 of file OgreMovableObject.h.

static void Ogre::ShadowCaster::extrudeVertices | ( | const HardwareVertexBufferSharedPtr & | vertexBuffer,
|  | size_t | originalVertexCount,
|  | const Vector4 & | lightPos,
|  | Real | extrudeDist |
| ) |  |  | `[static, inherited]`

Utility method for extruding vertices based on a light.

Remarks:
  Unfortunately, because D3D cannot handle homogeneous (4D) position coordinates in the fixed-function pipeline (GL can, but we have to be cross-API), when we extrude in software we cannot extrude to infinity the way we do in the vertex program (by setting w to 0.0f). Therefore we extrude by a fixed distance, which may cause some problems with larger scenes. Luckily better hardware (ie vertex programs) can fix this.

Parameters:

  | vertexBuffer | The vertex buffer containing ONLY xyz position values, which must be originalVertexCount * 2 * 3 floats long.
  | originalVertexCount | The count of the original number of vertices, i.e. the number in the mesh, not counting the doubling which has already been done (by VertexData::prepareForShadowVolume) to provide the extruded area of the buffer.
  | lightPos | 4D light position in object space, when w=0.0f this represents a directional light
  | extrudeDist | The distance to extrude

Real Ogre::ShadowCaster::getExtrusionDistance | ( | const Vector3 & | objectPos,
|  | const Light * | light |
| ) |  |  | const`[protected, inherited]`

Helper method for calculating extrusion distance.

virtual void Ogre::ShadowCaster::updateEdgeListLightFacing | ( | EdgeData * | edgeData,
|  | const Vector4 & | lightPos |
| ) |  |  | `[protected, virtual, inherited]`

Tells the caster to perform the tasks necessary to update the edge data's light listing.

Can be overridden if the subclass needs to do additional things.

Parameters:

  | edgeData | The edge information to update
  | lightPos | 4D vector representing the light, a directional light has w=0.0

virtual void Ogre::ShadowCaster::generateShadowVolume | ( | EdgeData * | edgeData,
|  | const HardwareIndexBufferSharedPtr & | indexBuffer,
|  | const Light * | light,
|  | ShadowRenderableList & | shadowRenderables,
|  | unsigned long | flags |
| ) |  |  | `[protected, virtual, inherited]`

Generates the indexes required to render a shadow volume into the index buffer which is passed in, and updates shadow renderables to use it.

Parameters:

  | edgeData | The edge information to use
  | indexBuffer | The buffer into which to write data into; current contents are assumed to be discardable.
  | light | The light, mainly for type info as silhouette calculations should already have been done in updateEdgeListLightFacing
  | shadowRenderables | A list of shadow renderables which has already been constructed but will need populating with details of the index ranges to be used.
  | flags | Additional controller flags, see ShadowRenderableFlags

virtual void Ogre::ShadowCaster::extrudeBounds | ( | AxisAlignedBox & | box,
|  | const Vector4 & | lightPos,
|  | Real | extrudeDist |
| ) |  |  | const`[protected, virtual, inherited]`

Utility method for extruding a bounding box.

Parameters:

  | box | Original bounding box, will be updated in-place
  | lightPos | 4D light position in object space, when w=0.0f this represents a directional light
  | extrudeDist | The distance to extrude

virtual const String& Ogre::AnimableObject::getAnimableDictionaryName | ( | void |  | ) | const`[protected, virtual, inherited]`

Get the name of the animable dictionary for this class.

Remarks:
  Subclasses must override this if they want to support animation of their values.

Reimplemented in Ogre::Light.

Definition at line 242 of file OgreAnimable.h.

References Ogre::StringUtil::BLANK.

void Ogre::AnimableObject::createAnimableDictionary | ( | void |  | ) | const`[protected, inherited]`

Internal method for creating a dictionary of animable value names for the class, if it does not already exist.

Definition at line 247 of file OgreAnimable.h.

StringVector& Ogre::AnimableObject::_getAnimableValueNames | ( | void |  | ) | `[protected, inherited]`

Get an updateable reference to animable value list.

Definition at line 260 of file OgreAnimable.h.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

virtual void Ogre::AnimableObject::initialiseAnimableDictionary | ( | StringVector & |  | ) | const`[protected, virtual, inherited]`

Internal method for initialising dictionary; should be implemented by subclasses wanting to expose animable parameters.

Reimplemented in Ogre::Light.

Definition at line 280 of file OgreAnimable.h.

const StringVector& Ogre::AnimableObject::getAnimableValueNames | ( | void |  | ) | const`[inherited]`

Gets a list of animable value names for this object.

Definition at line 288 of file OgreAnimable.h.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

virtual AnimableValuePtr Ogre::AnimableObject::createAnimableValue | ( | const String & | valueName | ) | `[virtual, inherited]`

Create a reference-counted AnimableValuePtr for the named value.

Remarks:
  You can use the returned object to animate a value on this object, using AnimationTrack. Subclasses must override this if they wish to support animation of their values.

Reimplemented in Ogre::Light.

Definition at line 313 of file OgreAnimable.h.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 62 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 73 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 79 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 84 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 89 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 106 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

virtual Technique* Ogre::Renderable::getTechnique | ( | void |  | ) | const`[virtual, inherited]`

Retrieves a pointer to the Material Technique this renderable object uses.

Remarks:
  This is to allow Renderables to use a chosen Technique if they wish, otherwise they will use the best Technique available for the Material they are using.

Reimplemented in Ogre::InstancedGeometry::GeometryBucket, Ogre::StaticGeometry::GeometryBucket, and Ogre::SubEntity.

Definition at line 87 of file OgreRenderable.h.

virtual bool Ogre::Renderable::preRender | ( | SceneManager * | sm,
|  | RenderSystem * | rsys |
| ) |  |  | `[virtual, inherited]`

Called just prior to the Renderable being rendered.

Remarks:
  OGRE is a queued renderer, so the actual render commands are executed at a later time than the point at which an object is discovered to be visible. This allows ordering & grouping of renders without the discovery process having to be aware of it. It also means OGRE uses declarative render information rather than immediate mode rendering - this is very useful in that certain effects and processes can automatically be applied to a wide range of scenes, but the downside is that special cases are more difficult to handle, because there is not the declared state to cope with it.

  This method allows a Renderable to do something special at the actual point of rendering if it wishes to. When this method is called, all the material render state as declared by this Renderable has already been set, all that is left to do is to bind the buffers and perform the render. The Renderable may modify render state itself if it wants to (and restore it in the postRender call) before the automated render happens, or by returning 'false' from this method can actually suppress the automatic render and perform one of its own.

Returns:
  true if the automatic render should proceed, false to skip it on the assumption that the Renderable has done it manually.

Definition at line 116 of file OgreRenderable.h.

virtual void Ogre::Renderable::postRender | ( | SceneManager * | sm,
|  | RenderSystem * | rsys |
| ) |  |  | `[virtual, inherited]`

Called immediately after the Renderable has been rendered.

Definition at line 119 of file OgreRenderable.h.

virtual unsigned short Ogre::Renderable::getNumWorldTransforms | ( | void |  | ) | const`[virtual, inherited]`

Returns the number of world transform matrices this renderable requires.

Remarks:
  When a renderable uses vertex blending, it uses multiple world matrices instead of a single one. Each vertex sent to the pipeline can reference one or more matrices in this list with given weights. If a renderable does not use vertex blending this method returns 1, which is the default for simplicity.

Reimplemented in Ogre::BorderRenderable, Ogre::InstancedGeometry::GeometryBucket, and Ogre::SubEntity.

Definition at line 143 of file OgreRenderable.h.

void Ogre::Renderable::setUseIdentityProjection | ( | bool | useIdentityProjection | ) | `[inherited]`

Sets whether or not to use an 'identity' projection.

Remarks:
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also:
  Renderable::getUseIdentityProjection

Definition at line 154 of file OgreRenderable.h.

bool Ogre::Renderable::getUseIdentityProjection | ( | void |  | ) | const`[inherited]`

Returns whether or not to use an 'identity' projection.

Remarks:
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this.

See also:
  Renderable::setUseIdentityProjection

Definition at line 168 of file OgreRenderable.h.

void Ogre::Renderable::setUseIdentityView | ( | bool | useIdentityView | ) | `[inherited]`

Sets whether or not to use an 'identity' view.

Remarks:
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also:
  Renderable::getUseIdentityView

Definition at line 179 of file OgreRenderable.h.

bool Ogre::Renderable::getUseIdentityView | ( | void |  | ) | const`[inherited]`

Returns whether or not to use an 'identity' view.

Remarks:
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this.

See also:
  Renderable::setUseIdentityView

Definition at line 193 of file OgreRenderable.h.

virtual bool Ogre::Renderable::getCastsShadows | ( | void |  | ) | const`[virtual, inherited]`

Method which reports whether this renderable would normally cast a shadow.

Remarks:
  Subclasses should override this if they could have been used to generate a shadow.

Reimplemented in Ogre::InstancedGeometry::GeometryBucket, Ogre::StaticGeometry::GeometryBucket, and Ogre::SubEntity.

Definition at line 214 of file OgreRenderable.h.

void Ogre::Renderable::setCustomParameter | ( | size_t | index,
|  | const Vector4 & | value |
| ) |  |  | `[inherited]`

Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.

Remarks:
  Calling this method simply associates a numeric index with a 4-dimensional value for this specific Renderable. This is most useful if the material which this Renderable uses a vertex or fragment program, and has an ACT_CUSTOM parameter entry. This parameter entry can refer to the index you specify as part of this call, thereby mapping a custom parameter for this renderable to a program parameter.

Parameters:

  | index | The index with which to associate the value. Note that this does not have to start at 0, and can include gaps. It also has no direct correlation with a GPU program parameter index - the mapping between the two is performed by the ACT_CUSTOM entry, if that is used.
  | value | The value to associate.

Definition at line 231 of file OgreRenderable.h.

const Vector4& Ogre::Renderable::getCustomParameter | ( | size_t | index | ) | const`[inherited]`

Gets the custom value associated with this Renderable at the given index.

Parameters:

  | @see | setCustomParaemter for full details.

Definition at line 240 of file OgreRenderable.h.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

virtual void Ogre::Renderable::_updateCustomGpuParameter | ( | const GpuProgramParameters::AutoConstantEntry & | constantEntry,
|  | GpuProgramParameters * | params |
| ) |  |  | const`[virtual, inherited]`

Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.

Remarks:
  This method allows a Renderable to map in a custom GPU program parameter based on it's own data. This is represented by a GPU auto parameter of ACT_CUSTOM, and to allow there to be more than one of these per Renderable, the 'data' field on the auto parameter will identify which parameter is being updated. The implementation of this method must identify the parameter being updated, and call a 'setConstant' method on the passed in GpuProgramParameters object, using the details provided in the incoming auto constant setting to identify the index at which to set the parameter.

  You do not need to override this method if you're using the standard sets of data associated with the Renderable as provided by setCustomParameter and getCustomParameter. By default, the implementation will map from the value indexed by the 'constantEntry.data' parameter to a value previously set by setCustomParameter. But custom Renderables are free to override this if they want, in any case.

Parameters:

  | constantEntry | The auto constant entry referring to the parameter being updated
  | params | The parameters object which this method should call to set the updated parameters.

Reimplemented in Ogre::SubEntity.

Definition at line 279 of file OgreRenderable.h.

References Ogre::GpuProgramParameters::_writeRawConstant(), Ogre::GpuProgramParameters::AutoConstantEntry::data, Ogre::GpuProgramParameters::AutoConstantEntry::elementCount, and Ogre::GpuProgramParameters::AutoConstantEntry::physicalIndex.

virtual void Ogre::Renderable::setPolygonModeOverrideable | ( | bool | override | ) | `[virtual, inherited]`

Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

Parameters:

  | override | true means that a lower camera detail will override this renderables detail level, false means it won't.

Definition at line 296 of file OgreRenderable.h.

virtual bool Ogre::Renderable::getPolygonModeOverrideable | ( | void |  | ) | const`[virtual, inherited]`

Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

Reimplemented in Ogre::BorderRenderable.

Definition at line 304 of file OgreRenderable.h.

virtual RenderSystemData* Ogre::Renderable::getRenderSystemData | ( |  | ) | const`[virtual, inherited]`

Sets render system private data.

Remarks:
  This should only be used by a render system

Definition at line 356 of file OgreRenderable.h.

virtual void Ogre::Renderable::setRenderSystemData | ( | RenderSystemData * | val | ) | const`[virtual, inherited]`

gets render system private data

Remarks:
  This should only be used by a render system

Definition at line 364 of file OgreRenderable.h.

virtual void Ogre::Node::Listener::nodeAttached | ( | const Node * |  | ) | `[virtual, inherited]`

Node has been attached to a parent.

Definition at line 90 of file OgreNode.h.

virtual void Ogre::Node::Listener::nodeDetached | ( | const Node * |  | ) | `[virtual, inherited]`

Node has been detached from a parent.

Definition at line 92 of file OgreNode.h.

## Member Data Documentation

NodeList Ogre::RibbonTrail::mNodeList`[protected]`

List of nodes being trailed.

Definition at line 174 of file OgreRibbonTrail.h.

IndexVector Ogre::RibbonTrail::mNodeToChainSegment`[protected]`

Ordered like mNodeList, contains chain index.

Definition at line 178 of file OgreRibbonTrail.h.

IndexVector Ogre::RibbonTrail::mFreeChains`[protected]`

Definition at line 180 of file OgreRibbonTrail.h.

NodeToChainSegmentMap Ogre::RibbonTrail::mNodeToSegMap`[protected]`

Definition at line 185 of file OgreRibbonTrail.h.

Real Ogre::RibbonTrail::mTrailLength`[protected]`

Total length of trail in world units.

Definition at line 188 of file OgreRibbonTrail.h.

Real Ogre::RibbonTrail::mElemLength`[protected]`

length of each element

Definition at line 190 of file OgreRibbonTrail.h.

Real Ogre::RibbonTrail::mSquaredElemLength`[protected]`

Squared length of each element.

Definition at line 192 of file OgreRibbonTrail.h.

ColourValueList Ogre::RibbonTrail::mInitialColour`[protected]`

Initial colour of the ribbon.

Definition at line 196 of file OgreRibbonTrail.h.

ColourValueList Ogre::RibbonTrail::mDeltaColour`[protected]`

fade amount per second

Definition at line 198 of file OgreRibbonTrail.h.

RealList Ogre::RibbonTrail::mInitialWidth`[protected]`

Initial width of the ribbon.

Definition at line 200 of file OgreRibbonTrail.h.

RealList Ogre::RibbonTrail::mDeltaWidth`[protected]`

Delta width of the ribbon.

Definition at line 202 of file OgreRibbonTrail.h.

Controller<Real>* Ogre::RibbonTrail::mFadeController`[protected]`

controller used to hook up frame time to fader

Definition at line 204 of file OgreRibbonTrail.h.

ControllerValueRealPtr Ogre::RibbonTrail::mTimeControllerValue`[protected]`

controller value for hooking up frame time to fader

Definition at line 206 of file OgreRibbonTrail.h.

size_t Ogre::BillboardChain::mMaxElementsPerChain`[protected, inherited]`

Maximum length of each chain.

Definition at line 254 of file OgreBillboardChain.h.

size_t Ogre::BillboardChain::mChainCount`[protected, inherited]`

Number of chains.

Definition at line 256 of file OgreBillboardChain.h.

bool Ogre::BillboardChain::mUseTexCoords`[protected, inherited]`

Use texture coords?

Definition at line 258 of file OgreBillboardChain.h.

bool Ogre::BillboardChain::mUseVertexColour`[protected, inherited]`

Use vertex colour?

Definition at line 260 of file OgreBillboardChain.h.

bool Ogre::BillboardChain::mDynamic`[protected, inherited]`

Dynamic use?

Definition at line 262 of file OgreBillboardChain.h.

VertexData* Ogre::BillboardChain::mVertexData`[protected, inherited]`

Vertex data.

Definition at line 264 of file OgreBillboardChain.h.

IndexData* Ogre::BillboardChain::mIndexData`[protected, inherited]`

Index data (to allow multiple unconnected chains).

Definition at line 266 of file OgreBillboardChain.h.

bool Ogre::BillboardChain::mVertexDeclDirty`[protected, inherited]`

Is the vertex declaration dirty?

Definition at line 268 of file OgreBillboardChain.h.

bool Ogre::BillboardChain::mBuffersNeedRecreating`[protected, inherited]`

Do the buffers need recreating?

Definition at line 270 of file OgreBillboardChain.h.

bool Ogre::BillboardChain::mBoundsDirty`[mutable, protected, inherited]`

Do the bounds need redefining?

Definition at line 272 of file OgreBillboardChain.h.

bool Ogre::BillboardChain::mIndexContentDirty`[protected, inherited]`

Is the index buffer dirty?

Definition at line 274 of file OgreBillboardChain.h.

AxisAlignedBox Ogre::BillboardChain::mAABB`[mutable, protected, inherited]`

AABB.

Definition at line 276 of file OgreBillboardChain.h.

Real Ogre::BillboardChain::mRadius`[mutable, protected, inherited]`

Bounding radius.

Definition at line 278 of file OgreBillboardChain.h.

String Ogre::BillboardChain::mMaterialName`[protected, inherited]`

Material.

Definition at line 280 of file OgreBillboardChain.h.

MaterialPtr Ogre::BillboardChain::mMaterial`[protected, inherited]`

Definition at line 281 of file OgreBillboardChain.h.

TexCoordDirection Ogre::BillboardChain::mTexCoordDir`[protected, inherited]`

Texture coord direction.

Definition at line 283 of file OgreBillboardChain.h.

Real Ogre::BillboardChain::mOtherTexCoordRange[2]`[protected, inherited]`

Other texture coord range.

Definition at line 285 of file OgreBillboardChain.h.

ElementList Ogre::BillboardChain::mChainElementList`[protected, inherited]`

The list holding the chain elements.

Definition at line 289 of file OgreBillboardChain.h.

ChainSegmentList Ogre::BillboardChain::mChainSegmentList`[protected, inherited]`

Definition at line 308 of file OgreBillboardChain.h.

const size_t Ogre::BillboardChain::SEGMENT_EMPTY`[static, protected, inherited]`

Chain segment has no elements.

Definition at line 323 of file OgreBillboardChain.h.

String Ogre::MovableObject::mName`[protected, inherited]`

Name of this object.

Reimplemented in Ogre::Camera.

Definition at line 104 of file OgreMovableObject.h.

MovableObjectFactory* Ogre::MovableObject::mCreator`[protected, inherited]`

Creator of this object (if created by a factory).

Definition at line 106 of file OgreMovableObject.h.

SceneManager* Ogre::MovableObject::mManager`[protected, inherited]`

SceneManager holding this object (if applicable).

Definition at line 108 of file OgreMovableObject.h.

Node* Ogre::MovableObject::mParentNode`[protected, inherited]`

node to which this object is attached

Definition at line 110 of file OgreMovableObject.h.

bool Ogre::MovableObject::mParentIsTagPoint`[protected, inherited]`

Definition at line 111 of file OgreMovableObject.h.

bool Ogre::MovableObject::mVisible`[protected, inherited]`

Is this object visible?

Definition at line 113 of file OgreMovableObject.h.

bool Ogre::MovableObject::mDebugDisplay`[protected, inherited]`

Is debug display enabled?

Definition at line 115 of file OgreMovableObject.h.

Real Ogre::MovableObject::mUpperDistance`[protected, inherited]`

Upper distance to still render.

Definition at line 117 of file OgreMovableObject.h.

Real Ogre::MovableObject::mSquaredUpperDistance`[protected, inherited]`

Definition at line 118 of file OgreMovableObject.h.

bool Ogre::MovableObject::mBeyondFarDistance`[protected, inherited]`

Hidden because of distance?

Definition at line 120 of file OgreMovableObject.h.

Any Ogre::MovableObject::mUserAny`[protected, inherited]`

User defined link to another object / value / whatever.

Definition at line 122 of file OgreMovableObject.h.

Any Ogre::Renderable::mUserAny`[protected, inherited]`

Definition at line 376 of file OgreRenderable.h.

uint8 Ogre::MovableObject::mRenderQueueID`[protected, inherited]`

The render queue to use when rendering this object.

Definition at line 124 of file OgreMovableObject.h.

bool Ogre::MovableObject::mRenderQueueIDSet`[protected, inherited]`

Flags whether the RenderQueue's default should be used.

Definition at line 126 of file OgreMovableObject.h.

uint32 Ogre::MovableObject::mQueryFlags`[protected, inherited]`

Flags determining whether this object is included / excluded from scene queries.

Definition at line 128 of file OgreMovableObject.h.

uint32 Ogre::MovableObject::mVisibilityFlags`[protected, inherited]`

Flags determining whether this object is visible (compared to SceneManager mask).

Definition at line 130 of file OgreMovableObject.h.

AxisAlignedBox Ogre::MovableObject::mWorldAABB`[mutable, protected, inherited]`

Cached world AABB of this object.

Reimplemented in Ogre::ParticleSystem.

Definition at line 132 of file OgreMovableObject.h.

Sphere Ogre::MovableObject::mWorldBoundingSphere`[mutable, protected, inherited]`

Definition at line 134 of file OgreMovableObject.h.

AxisAlignedBox Ogre::MovableObject::mWorldDarkCapBounds`[mutable, protected, inherited]`

World space AABB of this object's dark cap.

Definition at line 136 of file OgreMovableObject.h.

bool Ogre::MovableObject::mCastShadows`[protected, inherited]`

Does this object cast shadows?

Definition at line 138 of file OgreMovableObject.h.

bool Ogre::MovableObject::mRenderingDisabled`[protected, inherited]`

Does rendering this object disabled by listener?

Definition at line 141 of file OgreMovableObject.h.

Listener* Ogre::MovableObject::mListener`[protected, inherited]`

MovableObject listener - only one allowed (no list) for size & performance reasons. */.

Definition at line 143 of file OgreMovableObject.h.

LightList Ogre::MovableObject::mLightList`[mutable, protected, inherited]`

List of lights for this object.

Reimplemented in Ogre::StaticGeometry::Region.

Definition at line 146 of file OgreMovableObject.h.

ulong Ogre::MovableObject::mLightListUpdated`[mutable, protected, inherited]`

The last frame that this light list was updated in.

Reimplemented in Ogre::StaticGeometry::Region.

Definition at line 148 of file OgreMovableObject.h.

uint32 Ogre::MovableObject::msDefaultQueryFlags`[static, protected, inherited]`

Default query flags.

Definition at line 152 of file OgreMovableObject.h.

uint32 Ogre::MovableObject::msDefaultVisibilityFlags`[static, protected, inherited]`

Default visibility flags.

Definition at line 154 of file OgreMovableObject.h.

AnimableDictionaryMap Ogre::AnimableObject::msAnimableDictionary`[static, protected, inherited]`

Static map of class name to list of animable value names.

Definition at line 236 of file OgreAnimable.h.

CustomParameterMap Ogre::Renderable::mCustomParameters`[protected, inherited]`

Definition at line 372 of file OgreRenderable.h.

bool Ogre::Renderable::mPolygonModeOverrideable`[protected, inherited]`

Definition at line 373 of file OgreRenderable.h.

bool Ogre::Renderable::mUseIdentityProjection`[protected, inherited]`

Definition at line 374 of file OgreRenderable.h.

bool Ogre::Renderable::mUseIdentityView`[protected, inherited]`

Definition at line 375 of file OgreRenderable.h.

RenderSystemData* Ogre::Renderable::mRenderSystemData`[mutable, protected, inherited]`

Definition at line 377 of file OgreRenderable.h.

The documentation for this class was generated from the following file:

- OgreRibbonTrail.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sun Jul 26 11:35:53 2009